您的位置:首页 > 其它

Leetcode 278. First Bad Version

2016-10-04 02:55 169 查看


278. First Bad Version

Total Accepted: 64297 Total Submissions: 270446 Difficulty: Easy

You are a product manager and currently leading a team to develop a new product. Unfortunately, the latest version of your product fails the quality 
check. Since each version is developed based on the previous version, all the versions after a bad version are also bad.
Suppose you have 
n
 versions 
[1,
2, ..., n]
 and you want to find out the first bad one, which causes all the following ones to be bad.
You are given an API 
bool isBadVersion(version)
 which
will return whether 
version
 is bad. Implement a function to find the first bad version.
 You should minimize the number of calls to the API.
Credits:

Special thanks to @jianchao.li.fighter for adding this problem and creating all test cases.

Hide Company Tags
 Facebook

Hide Tags
 Binary Search

Hide Similar Problems
 (M) Search for a Range (M)
Search Insert Position (E) Guess Number Higher or Lower

思路:

二分法。

可以用递归也可以用iterative的。

注意事项是mid = (low+high)/2 不行,因为数据溢出。要改成left + 两者差的一半。

递归:21ms

/* The isBadVersion API is defined in the parent class VersionControl.
boolean isBadVersion(int version); */

public class Solution extends VersionControl {
public int firstBadVersion(int n) {
int res = helper(1, n);
return res;
}

public int helper(int left, int right){
if(left == right) return left;
int mid = (right - left)/2 + left;
if(isBadVersion(mid)) return helper(left, mid);
else return helper(mid + 1, right);
}
}
Iterative: 17ms

/* The isBadVersion API is defined in the parent class VersionControl.
boolean isBadVersion(int version); */

public class Solution extends VersionControl {
public int firstBadVersion(int n) {
int low = 0;
int high = n;
while (low < high) {
int mid = low + (high - low) / 2;
if (isBadVersion(mid))
high = mid;
else low = mid + 1;
}
return low;
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  Binary Search